corelinux::Prototype< TypeImpl > Class Template Referenceabstract

Specify the kinds of objects to create using a prototypical instance, and create new objects by copying (cloning) this prototype. More...

`#include <Prototype.hpp>`

## Public Member Functions

| Prototype (void)
| Default constructor.
| Prototype (const Prototype &aPrototype)
| Copy constructor. More...
virtual | ~Prototype (void)
| Virtual destructor.
Prototype & | operator= (const Prototype &aPrototype)
| Assignment operator. More...
bool | operator== (const Prototype &aPrototype) const
| Equality operator. More...
virtual TypeImpl * | clone (void) const =0
| clone is used to create a copy of the current prototype instance. More...
Public Member Functions inherited from corelinux::CoreLinuxObject
| CoreLinuxObject (void)
| Default Constructor.
| CoreLinuxObject (CoreLinuxObjectCref)
| Copy Constructor. More...
virtual | ~CoreLinuxObject (void)
| Virtual Destructor.
CoreLinuxObjectRef | operator= (CoreLinuxObjectCref)
| Assignment operator overload. More...
bool | operator== (CoreLinuxObjectCref) const
| Equality operator overload. More...
bool | operator!= (CoreLinuxObjectCref) const
| Non-equality operator overload. More...

## Detailed Description

### template<class TypeImpl>
class corelinux::Prototype< TypeImpl >

Specify the kinds of objects to create using a prototypical instance, and create new objects by copying (cloning) this prototype.

## Constructor & Destructor Documentation

template<class TypeImpl >

corelinux::Prototype< TypeImpl >::Prototype | ( | const Prototype< TypeImpl > & | aPrototype | ) |

inline

Copy constructor.

Parameters

  Prototype | const reference

## Member Function Documentation

template<class TypeImpl >

virtual TypeImpl* corelinux::Prototype< TypeImpl >::clone | ( | void |  | ) | const

pure virtual

clone is used to create a copy of the current prototype instance.

Returns
  TypeImpl pointer

template<class TypeImpl >

Prototype& corelinux::Prototype< TypeImpl >::operator= | ( | const Prototype< TypeImpl > & | aPrototype | ) |

inline

Assignment operator.

Parameters

  Prototype | const reference

Returns
  Prototype reference to this instance

References corelinux::CoreLinuxObject::operator=().

template<class TypeImpl >

bool corelinux::Prototype< TypeImpl >::operator== | ( | const Prototype< TypeImpl > & | aPrototype | ) | const

inline

Equality operator.

Parameters

  Prototype | const reference

Returns
  bool if instances are same

References corelinux::CoreLinuxObject::operator==().

The documentation for this class was generated from the following file:

- Prototype.hpp

This is the CoreLinux++ reference manual
Provided by The CoreLinux Consortium